<template>
  <q-layout class="login-bg" style="background: radial-gradient(circle, #35a2ff 0%, #014a88 100%)">
    <q-page-container>
      <q-page class="fullscreen bg-primary" padding>
        <div class="row items-center justify-center full-height">
          <div class="col-12" style="max-width: 460px;">
            <q-card class="q-pa-md">
              <q-form
                @submit.prevent="submit"
              >
                <q-card-section class="text-center">
                  <p class="text-h4">
                    Agent Management System
                  </p>
                </q-card-section>
                <q-card-section>
                  <q-input v-model="$v.form.username.$model"
                           :error="$v.form.username.$error"
                           error-message="Username is required."
                           label="Username">
                    <template v-slot:prepend>
                      <q-icon name="lock"/>
                    </template>
                  </q-input>
                  <q-input v-model="$v.form.password.$model"
                           :error="$v.form.username.$error"
                           error-message="Password is required."
                           label="Password" type="password">
                    <template v-slot:prepend>
                      <q-icon name="password"/>
                    </template>
                  </q-input>
                </q-card-section>
                <q-card-section>
                  <div class="row">
                    <div class="col">
                      <q-btn class="full-width" type="submit" color="primary">Login</q-btn>
                    </div>
                  </div>
                </q-card-section>
              </q-form>
            </q-card>
          </div>
        </div>
      </q-page>
    </q-page-container>
  </q-layout>
</template>

<script>
import { TimePicker} from "element-ui";
import {required} from 'vuelidate/lib/validators'
import {mapActions, mapMutations} from 'vuex'
export default {
  name: 'login_page',
  data() {
    return {
      form: {
        username: '',
        password: ''
      },
    };
  },
  validations: {
    form: {
      username: {
        required
      },
      password: {
        required
      }
    }
  },
  methods: {
    ...mapActions('auth', ['auth']),
    ...mapMutations('auth', ['set_user']),
    async submit(e) {
      this.$q.loading.show();
      try {
        this.$v.form.$touch();
        if (!this.$v.form.invalid) {
          const {data} = await this.auth(this.form);
          this.set_user(data);
          await this.$router.push('/v2');
        }
        this.$q.loading.hide();
      } catch (e) {
        this.$q.loading.hide();
        if (e.response) {
          this.$q.dialog({
            message: e.response.data.message
          });
        } else {
          this.$q.dialog({
            message: e.message
          });
        }
      }
    }
  }
}
</script>
